<template>
	<f7-page name="inventorydetail" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title v-if="inventory && inventory.category" class="show-small-title">Inventaris</f7-nav-title>
            <f7-nav-title-large v-if="inventory && inventory.category">{{ inventory.category.name }}</f7-nav-title-large>
            <f7-nav-right>
                <f7-link href="/inventory/create/" icon-f7="add" color="smoothgray" icon-only></f7-link>
            </f7-nav-right>
		</f7-navbar>
        <f7-block v-if="inventory && inventory.category">
            <f7-swiper v-if="inventory.medias != null" pagination :params="{loop: false, speed:900, slidesPerView: 1, spaceBetween: 20}">
                <f7-swiper-slide class="inventory-has-browser" v-for="item in inventory.medias" v-bind:key="item.id">
                    <span class="image-thumb" :style="`background-image: url(${item.url.medium});`"></span>
                </f7-swiper-slide>
            </f7-swiper>
            <div class="inventory-detail">
                <h3>{{ inventory.title }}</h3>
                <f7-list>
                    <f7-list-item title="No." :after="inventory.number"></f7-list-item>
                    <f7-list-item title="Kuantitas" :badge="inventory.quantity"></f7-list-item>
                    <f7-list-item title="Diterima" :after="dateFormat(inventory.received, 'DD/MM/YYYY')"></f7-list-item>
                    <f7-list-item v-if="inventory.description" title="Catatan" :text="inventory.description"></f7-list-item>
                </f7-list>
                <div style="margin-top:20px;" v-if="inventory.description">
                    <h3>Catatan:</h3>
                    <p>{{ inventory.description }}</p>
                </div>
                <f7-button v-if="inventory" href="/inventory/create/" fill-ios round-ios color="white" icon-f7="paper_plane" class="gradient-button text-align-left" large>Buat Permintaan Pinjam / Sewa</f7-button>
            </div>
        </f7-block>        
	</f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { dateFormat } from '../js/utils';
export default {
    name: 'InventoryDetail',
    data(){
        return {
            photoBrowser: null
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
		...mapGetters('inventory', [
			'inventory'
		])
    },
    methods: {
        dateFormat,
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            app.preloader.show('green');

            self.$store.dispatch('inventory/viewInventory', {
                id: self.$f7route.params.id,
                only: 'id,number,title,quantity,received_date,residential.name,residential.administrative_region,residential.address,created,updated,medias.id,medias.mimetype,medias.original_filename,medias.filename,medias.url,author.id,author.profile.fullname,author.profile.initial,author.profile.media,category.id,category.name'
            }).then(() => {
                app.preloader.hide();
                self.phottoBrowserInit();
            });
        },
        onPageBeforeOut(){
            const self = this;
            const app = self.$f7;

            self.$store.dispatch('inventory/resetInventory');
            self.photoBrowser.destroy();
        },
        phottoBrowserInit(){
            const self = this;
            const app = self.$f7;
            const $$ = self.$$;

            if(self.inventory.medias != null){
                let medias = self.inventory.medias.map((x) => x.url.original);
                self.photoBrowser = app.photoBrowser.create({
                    photos: medias,
                    type: 'popup'
                });

                $$(document).on('click', '.inventory-has-browser', function(){
                    self.photoBrowser.open();
                });
            }
        }
    }
}
</script>
